<template>
  <div
    data-component-group="filter-forms"
    data-component="shop"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <v-text-field
        v-model="search"
        type="search"
        label="Search"
        prepend-inner-icon="search"
      />

      <v-autocomplete
        v-model="status"
        :items="statuses"
        :filter="customFilter"
        prepend-inner-icon="change_history"
        :return-object="true"
        item-text="name"
        label="Status"
        :menu-props="{nudgeBottom:'10'}"
      />
    </FiltersForm>
  </div>
</template>

<script>
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import FiltersForm from './Filters';
  import { isNum } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        search: '',
        status: {},
        colors
      };
    },
    computed: {
      hasFilters() {
        const { search, status } = this;

        return search !== '' || isNum(status.id);
      },
      statuses() {
        return this.$store.getters['shops/statuses'];
      }
    },
    methods: {
      onFilter() {
        const { search, status } = this;
        const formattedSearch = stringEscape(search);

        this.$emit('filter', {
          search: formattedSearch,
          status: status.id
        });
      },
      onClearFilters() {
        this.search = '';
        this.status = {};

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  [data-component-group="filter-forms"] {
    &[data-component="shop"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }
    }
  }
</style>
